Package org.jcsp.plugNplay

# Class Plex2

java.lang.Object
org.jcsp.plugNplay.Plex2

All Implemented Interfaces:
  `CSProcess`

public final class Plex2 extends Object implements CSProcess
Fair multiplexes two Object streams into one.

## Process Diagram

        in0  _______
       -->--|       | out
        in1 | Plex2 |-->--
       -->--|_______|

## Description

`Plex2` is a process whose output stream is a fair multiplexing of its input streams. It makes no assumptions about the traffic patterns occuring on the input streams and ensures that no input stream will be starved by busy siblings. It guarantees that if an input stream has data pending, no other stream will be serviced twice before that data is serviced.

## Channel Protocols

Input Channels
in0, in1 | java.lang.Object | The input streams.
Output Channels
out | java.lang.Object | The multiplexed output stream.

## Example

The following example shows how to use `Plex2` in a small program. The program also uses some of the other `plugNplay` processes.

     import org.jcsp.lang.*;
     import org.jcsp.plugNplay.*;

     public class Plex2Example {

       public static void main (String[] argv) {

         final One2OneChannel[] a = Channel.one2oneArray (2);
         final One2OneChannel[] b = Channel.one2oneArray (2);
         final One2OneChannel c = Channel.one2one ();

         new Parallel (
           new CSProcess[] {
             new Fibonacci (a[0].out ()),
             new Squares (a[1].out ()),
             new Sign ("Fibonacci ", a[0].in (), b[0].out ()),
             new Sign ("              Squares ", a[1].in (), b[1].out ()),
             new Plex2 (b[0].in (), b[1].in (), c.out ()),
             new Printer (c.in (), "", "\n")
           }
         ).run ();

       }

     }

## Implemntation Note

For information, here is the `run` method for this process:

       public void run () {
         AltingChannelInput[] input = {in0, in1};         // in0 and in1 are the input channels
         Alternative alt = new Alternative (input);
         while (true) {
           out.write (input[alt.fairSelect ()].read ());  // out is the output channel
         }
       }

Author:
  P.H. Welch
See Also:
  - `Plex`
  - `Multiplex`

## Constructor Summary

Constructors
Constructor
Description
`Plex2(AltingChannelInput in0, AltingChannelInput in1, ChannelOutput out)`
Construct a new `Plex2` process with the input channels `in0` and `in1` and the output channel `out`.

## Method Summary

Modifier and Type
Method
Description
`void`
`run()`
The main body of this process.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Plex2

public Plex2(AltingChannelInput in0, AltingChannelInput in1, ChannelOutput out)
Construct a new `Plex2` process with the input channels `in0` and `in1` and the output channel `out`. The ordering of the input channels makes no difference to the behaviour of this process.

Parameters:
  `in0` - an input channel
  `in1` - an input channel
  `out` - the output channel

## Method Details

### run

public void run()
The main body of this process.

Specified by:
  `run` in interface `CSProcess`